# Poco::Net

# class RawSocketImpl

Library: Net
Package: Sockets
Header: Poco/Net/RawSocketImpl.h

## Description

This class implements a raw socket.

## Inheritance

Direct Base Classes: SocketImpl

All Base Classes: SocketImpl, Poco::RefCountedObject

Known Derived Classes: ICMPSocketImpl

## Member Summary

Member Functions: init, init2

Inherited Functions: acceptConnection, address, available, bind, bind6, checkBrokenTimeout, close, connect, connectNB, duplicate, error, fcntl, getBlocking, getBroadcast, getError, getKeepAlive, getLinger, getNoDelay, getOOBInline, getOption, getRawOption, getReceiveBufferSize, getReceiveTimeout, getReuseAddress, getReusePort, getSendBufferSize, getSendTimeout, init, initSocket, initialized, ioctl, lastError, listen, peerAddress, poll, receiveBytes, receiveFrom, referenceCount, release, reset, secure, sendBytes, sendTo, sendUrgent, setBlocking, setBroadcast, setKeepAlive, setLinger, setNoDelay, setOOBInline, setOption, setRawOption, setReceiveBufferSize, setReceiveTimeout, setReuseAddress, setReusePort, setSendBufferSize, setSendTimeout, shutdown, shutdownReceive, shutdownSend, socketError, sockfd, type

## Constructors

### RawSocketImpl

RawSocketImpl();

Creates an unconnected IPv4 raw socket with IPPROTO_RAW.

### RawSocketImpl

RawSocketImpl(
int sockfd
);

Creates a RawSocketImpl using the given native socket.

### RawSocketImpl

RawSocketImpl(
SocketAddress::Family family,
int proto = IPPROTO_RAW
);

Creates an unconnected raw socket.

The socket will be created for the given address family.

## Destructor

### ~RawSocketImpl

~RawSocketImpl();

## Member Functions

### init

void init(
int af
);

See also: Poco::Net::SocketImpl::init()

### init2

void init2(
int af,
int proto
);